Loading...
Searching...
No Matches
ext2_fs.h File Reference

Go to the source code of this file.

## Data Structures

struct | ext2_dir_entry_2
struct | ext2_group_desc
struct | ext2_inode

## Macros

#define | EXT2_ACL_DATA_INO 4 /* ACL inode */
#define | EXT2_ACL_IDX_INO 3 /* ACL inode */
#define | EXT2_BAD_INO 1 /* Bad blocks inode */
#define | EXT2_BOOT_LOADER_INO 5 /* Boot loader inode */
#define | EXT2_DIND_BLOCK (EXT2_IND_BLOCK + 1)
#define | EXT2_DIRENT_FILE_TYPE(dir_ent)
#define | EXT2_DIRENT_INODE(dir_ent)
#define | EXT2_DIRENT_NAME_LEN(dir_ent)
#define | EXT2_DIRENT_REC_LEN(dir_ent)
#define | EXT2_ERROR_FS 0x0002
#define | EXT2_ERRORS_CONTINUE 1 /* Continue execution */
#define | EXT2_ERRORS_DEFAULT EXT2_ERRORS_CONTINUE
#define | EXT2_ERRORS_PANIC 3 /* Panic */
#define | EXT2_ERRORS_RO 2 /* Remount fs read-only */
#define | EXT2_FEATURE_COMPAT_HAS_DIR_INDEX 0x0020
#define | EXT2_FEATURE_INCOMPAT_FILETYPE 0x0002
#define | EXT2_FEATURE_RO_COMPAT_LARGE_FILE 0x0002
#define | EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER 0x0001
#define | EXT2_FT_BLKDEV 4
#define | EXT2_FT_CHRDEV 3
#define | EXT2_FT_DIR 2
#define | EXT2_FT_FIFO 5
#define | EXT2_FT_REG_FILE 1
#define | EXT2_FT_SOCK 6
#define | EXT2_FT_SYMLINK 7
#define | EXT2_FT_UNKNOWN 0
#define | EXT2_GROUP_BLOCK_BITMAP(gd)
#define | EXT2_GROUP_FREE_BLOCKS_COUNT(gd)
#define | EXT2_GROUP_FREE_INODES_COUNT(gd)
#define | EXT2_GROUP_INODE_BITMAP(gd)
#define | EXT2_GROUP_INODE_TABLE(gd)
#define | EXT2_GROUP_USED_DIRS_COUNT(gd)
#define | EXT2_IND_BLOCK EXT2_NDIR_BLOCKS
#define | EXT2_INODE_ATIME(inode)
#define | EXT2_INODE_BLOCK(inode, blk)
#define | EXT2_INODE_BLOCKS(inode)
#define | EXT2_INODE_CTIME(inode)
#define | EXT2_INODE_DTIME(inode)
#define | EXT2_INODE_FLAGS(inode)
#define | EXT2_INODE_GID(inode)
#define | EXT2_INODE_LINKS_COUNT(inode)
#define | EXT2_INODE_MODE(inode)
#define | EXT2_INODE_MTIME(inode)
#define | EXT2_INODE_SIZE(inode)
#define | EXT2_INODE_TRANSLATOR(inode)
#define | EXT2_INODE_UID(inode)
#define | EXT2_MIN_BLOCK_SIZE 1024
#define | EXT2_N_BLOCKS (EXT2_TIND_BLOCK + 1)
#define | EXT2_NDIR_BLOCKS 12
#define | EXT2_OS_FREEBSD 3
#define | EXT2_OS_HURD 1
#define | EXT2_OS_LINUX 0
#define | EXT2_OS_LITES 4
#define | EXT2_OS_MASIX 2
#define | EXT2_RESERVED_INODE_COUNT 11
#define | EXT2_ROOT_INO 2 /* Root inode */
#define | EXT2_SUPER_ALGORITHM_USAGE_BITMAP(sb)
#define | EXT2_SUPER_BLOCK_GROUP_NR(sb)
#define | EXT2_SUPER_BLOCKS_COUNT(sb)
#define | EXT2_SUPER_BLOCKS_PER_GROUP(sb)
#define | EXT2_SUPER_CHECKINTERVAL(sb)
#define | EXT2_SUPER_CREATOR_OS(sb)
#define | EXT2_SUPER_DEF_RESGID(sb)
#define | EXT2_SUPER_DEF_RESUID(sb)
#define | EXT2_SUPER_ERRORS(sb)
#define | EXT2_SUPER_FEATURE_COMPAT(sb)
#define | EXT2_SUPER_FEATURE_INCOMPAT(sb)
#define | EXT2_SUPER_FEATURE_RO_COMPAT(sb)
#define | EXT2_SUPER_FIRST_DATA_BLOCK(sb)
#define | EXT2_SUPER_FIRST_INO(sb)
#define | EXT2_SUPER_FRAGS_PER_GROUP(sb)
#define | EXT2_SUPER_FREE_BLOCKS_COUNT(sb)
#define | EXT2_SUPER_FREE_INODES_COUNT(sb)
#define | EXT2_SUPER_INODE_SIZE(sb)
#define | EXT2_SUPER_INODES_COUNT(sb)
#define | EXT2_SUPER_INODES_PER_GROUP(sb)
#define | EXT2_SUPER_JOURNAL_DEV(sb)
#define | EXT2_SUPER_JOURNAL_INUM(sb)
#define | EXT2_SUPER_JOURNAL_UUID(sb)
#define | EXT2_SUPER_LAST_MOUNTED(sb)
#define | EXT2_SUPER_LAST_ORPHAN(sb)
#define | EXT2_SUPER_LASTCHECK(sb)
#define | EXT2_SUPER_LOG_BLOCK_SIZE(sb)
#define | EXT2_SUPER_LOG_FRAG_SIZE(sb)
#define | EXT2_SUPER_MAGIC(sb)
#define | EXT2_SUPER_MAGIC_CONST 0xEF53
#define | EXT2_SUPER_MAX_MNT_COUNT(sb)
#define | EXT2_SUPER_MINOR_REV_LEVEL(sb)
#define | EXT2_SUPER_MNT_COUNT(sb)
#define | EXT2_SUPER_MTIME(sb)
#define | EXT2_SUPER_R_BLOCKS_COUNT(sb)
#define | EXT2_SUPER_REV_LEVEL(sb)
#define | EXT2_SUPER_STATE(sb)
#define | EXT2_SUPER_UUID(sb)
#define | EXT2_SUPER_VOLUME_NAME(sb)
#define | EXT2_SUPER_WTIME(sb)
#define | EXT2_TIND_BLOCK (EXT2_DIND_BLOCK + 1)
#define | EXT2_UNDEL_DIR_INO 6 /* Undelete directory inode */
#define | EXT2_VALID_FS 0x0001
#define | EXT3_FEATURE_COMPAT_HAS_JOURNAL 0x0004
#define | EXT3_FEATURE_INCOMPAT_RECOVER 0x0004
#define | EXT4_FEATURE_INCOMPAT_64BIT 0x0080
#define | EXT4_FEATURE_INCOMPAT_EXTENTS 0x0040
#define | EXT4_FEATURE_INCOMPAT_FLEX_BG 0x0200
#define | EXT4_FEATURE_RO_COMPAT_DIR_NLINK 0x0020
#define | EXT4_FEATURE_RO_COMPAT_GDT_CSUM 0x0010
#define | EXT4_FEATURE_RO_COMPAT_HUGE_FILE 0x0008
#define | i_size_high i_dir_acl

## Functions

struct | __attribute__ ((packed)) ext2_super_block

## Macro Definition Documentation

## EXT2_ACL_DATA_INO

#define EXT2_ACL_DATA_INO 4 /* ACL inode */

## EXT2_ACL_IDX_INO

#define EXT2_ACL_IDX_INO 3 /* ACL inode */

## EXT2_BAD_INO

#define EXT2_BAD_INO 1 /* Bad blocks inode */

## EXT2_BOOT_LOADER_INO

#define EXT2_BOOT_LOADER_INO 5 /* Boot loader inode */

## EXT2_DIND_BLOCK

#define EXT2_DIND_BLOCK (EXT2_IND_BLOCK + 1)

## EXT2_DIRENT_FILE_TYPE

#define EXT2_DIRENT_FILE_TYPE | ( |  | dir_ent | ) |

Value:
((dir_ent).file_type)

## EXT2_DIRENT_INODE

#define EXT2_DIRENT_INODE | ( |  | dir_ent | ) |

Value:
(PED_LE32_TO_CPU((dir_ent).inode))
PED_LE32_TO_CPU
#define PED_LE32_TO_CPU(x)
Definition endian.h:78

## EXT2_DIRENT_NAME_LEN

#define EXT2_DIRENT_NAME_LEN | ( |  | dir_ent | ) |

Value:
((dir_ent).name_len)

## EXT2_DIRENT_REC_LEN

#define EXT2_DIRENT_REC_LEN | ( |  | dir_ent | ) |

Value:
(PED_LE16_TO_CPU((dir_ent).rec_len))
PED_LE16_TO_CPU
#define PED_LE16_TO_CPU(x)
Definition endian.h:76

## EXT2_ERROR_FS

#define EXT2_ERROR_FS 0x0002

## EXT2_ERRORS_CONTINUE

#define EXT2_ERRORS_CONTINUE 1 /* Continue execution */

## EXT2_ERRORS_DEFAULT

#define EXT2_ERRORS_DEFAULT EXT2_ERRORS_CONTINUE

## EXT2_ERRORS_PANIC

#define EXT2_ERRORS_PANIC 3 /* Panic */

## EXT2_ERRORS_RO

#define EXT2_ERRORS_RO 2 /* Remount fs read-only */

## EXT2_FEATURE_COMPAT_HAS_DIR_INDEX

#define EXT2_FEATURE_COMPAT_HAS_DIR_INDEX 0x0020

## EXT2_FEATURE_INCOMPAT_FILETYPE

#define EXT2_FEATURE_INCOMPAT_FILETYPE 0x0002

## EXT2_FEATURE_RO_COMPAT_LARGE_FILE

#define EXT2_FEATURE_RO_COMPAT_LARGE_FILE 0x0002

## EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER

#define EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER 0x0001

## EXT2_FT_BLKDEV

#define EXT2_FT_BLKDEV 4

## EXT2_FT_CHRDEV

#define EXT2_FT_CHRDEV 3

## EXT2_FT_DIR

#define EXT2_FT_DIR 2

## EXT2_FT_FIFO

#define EXT2_FT_FIFO 5

## EXT2_FT_REG_FILE

#define EXT2_FT_REG_FILE 1

## EXT2_FT_SOCK

#define EXT2_FT_SOCK 6

## EXT2_FT_SYMLINK

#define EXT2_FT_SYMLINK 7

## EXT2_FT_UNKNOWN

#define EXT2_FT_UNKNOWN 0

## EXT2_GROUP_BLOCK_BITMAP

#define EXT2_GROUP_BLOCK_BITMAP | ( |  | gd | ) |

Value:
(PED_LE32_TO_CPU((gd).bg_block_bitmap))

## EXT2_GROUP_FREE_BLOCKS_COUNT

#define EXT2_GROUP_FREE_BLOCKS_COUNT | ( |  | gd | ) |

Value:
(PED_LE16_TO_CPU((gd).bg_free_blocks_count))

## EXT2_GROUP_FREE_INODES_COUNT

#define EXT2_GROUP_FREE_INODES_COUNT | ( |  | gd | ) |

Value:
(PED_LE16_TO_CPU((gd).bg_free_inodes_count))

## EXT2_GROUP_INODE_BITMAP

#define EXT2_GROUP_INODE_BITMAP | ( |  | gd | ) |

Value:
(PED_LE32_TO_CPU((gd).bg_inode_bitmap))

## EXT2_GROUP_INODE_TABLE

#define EXT2_GROUP_INODE_TABLE | ( |  | gd | ) |

Value:
(PED_LE32_TO_CPU((gd).bg_inode_table))

## EXT2_GROUP_USED_DIRS_COUNT

#define EXT2_GROUP_USED_DIRS_COUNT | ( |  | gd | ) |

Value:
(PED_LE16_TO_CPU((gd).bg_used_dirs_count))

## EXT2_IND_BLOCK

#define EXT2_IND_BLOCK EXT2_NDIR_BLOCKS

## EXT2_INODE_ATIME

#define EXT2_INODE_ATIME | ( |  | inode | ) |

Value:
(PED_LE32_TO_CPU((inode).i_atime))

## EXT2_INODE_BLOCK

#define EXT2_INODE_BLOCK | ( |  | inode,
|  |  | blk )

Value:
(PED_LE32_TO_CPU((inode).i_block[blk]))

## EXT2_INODE_BLOCKS

#define EXT2_INODE_BLOCKS | ( |  | inode | ) |

Value:
(PED_LE32_TO_CPU((inode).i_blocks))

## EXT2_INODE_CTIME

#define EXT2_INODE_CTIME | ( |  | inode | ) |

Value:
(PED_LE32_TO_CPU((inode).i_ctime))

## EXT2_INODE_DTIME

#define EXT2_INODE_DTIME | ( |  | inode | ) |

Value:
(PED_LE32_TO_CPU((inode).i_dtime))

## EXT2_INODE_FLAGS

#define EXT2_INODE_FLAGS | ( |  | inode | ) |

Value:
(PED_LE32_TO_CPU((inode).i_flags))

## EXT2_INODE_GID

#define EXT2_INODE_GID | ( |  | inode | ) |

Value:
(PED_LE16_TO_CPU((inode).i_gid))

## EXT2_INODE_LINKS_COUNT

#define EXT2_INODE_LINKS_COUNT | ( |  | inode | ) |

Value:
(PED_LE16_TO_CPU((inode).i_links_count))

## EXT2_INODE_MODE

#define EXT2_INODE_MODE | ( |  | inode | ) |

Value:
(PED_LE16_TO_CPU((inode).i_mode))

## EXT2_INODE_MTIME

#define EXT2_INODE_MTIME | ( |  | inode | ) |

Value:
(PED_LE32_TO_CPU((inode).i_mtime))

## EXT2_INODE_SIZE

#define EXT2_INODE_SIZE | ( |  | inode | ) |

Value:
((uint64_t) PED_LE32_TO_CPU((inode).i_size) \
+ ((uint64_t) PED_LE32_TO_CPU((inode).i_size_high) << 32))
i_size_high
#define i_size_high
Definition ext2_fs.h:175

## EXT2_INODE_TRANSLATOR

#define EXT2_INODE_TRANSLATOR | ( |  | inode | ) |

Value:
(PED_LE32_TO_CPU((inode).osd1.hurd1.h_i_translator))

## EXT2_INODE_UID

#define EXT2_INODE_UID | ( |  | inode | ) |

Value:
(PED_LE16_TO_CPU((inode).i_uid))

## EXT2_MIN_BLOCK_SIZE

#define EXT2_MIN_BLOCK_SIZE 1024

## EXT2_N_BLOCKS

#define EXT2_N_BLOCKS (EXT2_TIND_BLOCK + 1)

## EXT2_NDIR_BLOCKS

#define EXT2_NDIR_BLOCKS 12

## EXT2_OS_FREEBSD

#define EXT2_OS_FREEBSD 3

## EXT2_OS_HURD

#define EXT2_OS_HURD 1

## EXT2_OS_LINUX

#define EXT2_OS_LINUX 0

## EXT2_OS_LITES

#define EXT2_OS_LITES 4

## EXT2_OS_MASIX

#define EXT2_OS_MASIX 2

## EXT2_RESERVED_INODE_COUNT

#define EXT2_RESERVED_INODE_COUNT 11

## EXT2_ROOT_INO

#define EXT2_ROOT_INO 2 /* Root inode */

## EXT2_SUPER_ALGORITHM_USAGE_BITMAP

#define EXT2_SUPER_ALGORITHM_USAGE_BITMAP | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_algorithm_usage_bitmap))

## EXT2_SUPER_BLOCK_GROUP_NR

#define EXT2_SUPER_BLOCK_GROUP_NR | ( |  | sb | ) |

Value:
(PED_LE16_TO_CPU((sb).s_block_group_nr))

## EXT2_SUPER_BLOCKS_COUNT

#define EXT2_SUPER_BLOCKS_COUNT | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_blocks_count))

## EXT2_SUPER_BLOCKS_PER_GROUP

#define EXT2_SUPER_BLOCKS_PER_GROUP | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_blocks_per_group))

## EXT2_SUPER_CHECKINTERVAL

#define EXT2_SUPER_CHECKINTERVAL | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_checkinterval))

## EXT2_SUPER_CREATOR_OS

#define EXT2_SUPER_CREATOR_OS | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_creator_os))

## EXT2_SUPER_DEF_RESGID

#define EXT2_SUPER_DEF_RESGID | ( |  | sb | ) |

Value:
(PED_LE16_TO_CPU((sb).s_def_resgid))

## EXT2_SUPER_DEF_RESUID

#define EXT2_SUPER_DEF_RESUID | ( |  | sb | ) |

Value:
(PED_LE16_TO_CPU((sb).s_def_resuid))

## EXT2_SUPER_ERRORS

#define EXT2_SUPER_ERRORS | ( |  | sb | ) |

Value:
(PED_LE16_TO_CPU((sb).s_errors))

## EXT2_SUPER_FEATURE_COMPAT

#define EXT2_SUPER_FEATURE_COMPAT | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_feature_compat))

## EXT2_SUPER_FEATURE_INCOMPAT

#define EXT2_SUPER_FEATURE_INCOMPAT | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_feature_incompat))

## EXT2_SUPER_FEATURE_RO_COMPAT

#define EXT2_SUPER_FEATURE_RO_COMPAT | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_feature_ro_compat))

## EXT2_SUPER_FIRST_DATA_BLOCK

#define EXT2_SUPER_FIRST_DATA_BLOCK | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_first_data_block))

## EXT2_SUPER_FIRST_INO

#define EXT2_SUPER_FIRST_INO | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_first_ino))

## EXT2_SUPER_FRAGS_PER_GROUP

#define EXT2_SUPER_FRAGS_PER_GROUP | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_frags_per_group))

## EXT2_SUPER_FREE_BLOCKS_COUNT

#define EXT2_SUPER_FREE_BLOCKS_COUNT | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_free_blocks_count))

## EXT2_SUPER_FREE_INODES_COUNT

#define EXT2_SUPER_FREE_INODES_COUNT | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_free_inodes_count))

## EXT2_SUPER_INODE_SIZE

#define EXT2_SUPER_INODE_SIZE | ( |  | sb | ) |

Value:
(PED_LE16_TO_CPU((sb).s_inode_size))

## EXT2_SUPER_INODES_COUNT

#define EXT2_SUPER_INODES_COUNT | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_inodes_count))

## EXT2_SUPER_INODES_PER_GROUP

#define EXT2_SUPER_INODES_PER_GROUP | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_inodes_per_group))

## EXT2_SUPER_JOURNAL_DEV

#define EXT2_SUPER_JOURNAL_DEV | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_journal_dev))

## EXT2_SUPER_JOURNAL_INUM

#define EXT2_SUPER_JOURNAL_INUM | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_journal_inum))

## EXT2_SUPER_JOURNAL_UUID

#define EXT2_SUPER_JOURNAL_UUID | ( |  | sb | ) |

Value:
((sb).s_journal_uuid)

## EXT2_SUPER_LAST_MOUNTED

#define EXT2_SUPER_LAST_MOUNTED | ( |  | sb | ) |

Value:
((sb).s_last_mounted)

## EXT2_SUPER_LAST_ORPHAN

#define EXT2_SUPER_LAST_ORPHAN | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_last_orphan))

## EXT2_SUPER_LASTCHECK

#define EXT2_SUPER_LASTCHECK | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_lastcheck))

## EXT2_SUPER_LOG_BLOCK_SIZE

#define EXT2_SUPER_LOG_BLOCK_SIZE | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_log_block_size))

## EXT2_SUPER_LOG_FRAG_SIZE

#define EXT2_SUPER_LOG_FRAG_SIZE | ( |  | sb | ) |

Value:
((int32_t) PED_LE32_TO_CPU((sb).s_log_frag_size))

## EXT2_SUPER_MAGIC

#define EXT2_SUPER_MAGIC | ( |  | sb | ) |

Value:
(PED_LE16_TO_CPU((sb).s_magic))

## EXT2_SUPER_MAGIC_CONST

#define EXT2_SUPER_MAGIC_CONST 0xEF53

## EXT2_SUPER_MAX_MNT_COUNT

#define EXT2_SUPER_MAX_MNT_COUNT | ( |  | sb | ) |

Value:
((int16_t) PED_LE16_TO_CPU((sb).s_max_mnt_count))

## EXT2_SUPER_MINOR_REV_LEVEL

#define EXT2_SUPER_MINOR_REV_LEVEL | ( |  | sb | ) |

Value:
(PED_LE16_TO_CPU((sb).s_minor_rev_level))

## EXT2_SUPER_MNT_COUNT

#define EXT2_SUPER_MNT_COUNT | ( |  | sb | ) |

Value:
(PED_LE16_TO_CPU((sb).s_mnt_count))

## EXT2_SUPER_MTIME

#define EXT2_SUPER_MTIME | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_mtime))

## EXT2_SUPER_R_BLOCKS_COUNT

#define EXT2_SUPER_R_BLOCKS_COUNT | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_r_blocks_count))

## EXT2_SUPER_REV_LEVEL

#define EXT2_SUPER_REV_LEVEL | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_rev_level))

## EXT2_SUPER_STATE

#define EXT2_SUPER_STATE | ( |  | sb | ) |

Value:
(PED_LE16_TO_CPU((sb).s_state))

## EXT2_SUPER_UUID

#define EXT2_SUPER_UUID | ( |  | sb | ) |

Value:
((sb).s_uuid)

## EXT2_SUPER_VOLUME_NAME

#define EXT2_SUPER_VOLUME_NAME | ( |  | sb | ) |

Value:
((sb).s_volume_name)

## EXT2_SUPER_WTIME

#define EXT2_SUPER_WTIME | ( |  | sb | ) |

Value:
(PED_LE32_TO_CPU((sb).s_wtime))

## EXT2_TIND_BLOCK

#define EXT2_TIND_BLOCK (EXT2_DIND_BLOCK + 1)

## EXT2_UNDEL_DIR_INO

#define EXT2_UNDEL_DIR_INO 6 /* Undelete directory inode */

## EXT2_VALID_FS

#define EXT2_VALID_FS 0x0001

## EXT3_FEATURE_COMPAT_HAS_JOURNAL

#define EXT3_FEATURE_COMPAT_HAS_JOURNAL 0x0004

## EXT3_FEATURE_INCOMPAT_RECOVER

#define EXT3_FEATURE_INCOMPAT_RECOVER 0x0004

## EXT4_FEATURE_INCOMPAT_64BIT

#define EXT4_FEATURE_INCOMPAT_64BIT 0x0080

## EXT4_FEATURE_INCOMPAT_EXTENTS

#define EXT4_FEATURE_INCOMPAT_EXTENTS 0x0040

## EXT4_FEATURE_INCOMPAT_FLEX_BG

#define EXT4_FEATURE_INCOMPAT_FLEX_BG 0x0200

## EXT4_FEATURE_RO_COMPAT_DIR_NLINK

#define EXT4_FEATURE_RO_COMPAT_DIR_NLINK 0x0020

## EXT4_FEATURE_RO_COMPAT_GDT_CSUM

#define EXT4_FEATURE_RO_COMPAT_GDT_CSUM 0x0010

## EXT4_FEATURE_RO_COMPAT_HUGE_FILE

#define EXT4_FEATURE_RO_COMPAT_HUGE_FILE 0x0008

## i_size_high

#define i_size_high i_dir_acl

## Function Documentation

## __attribute__()

struct __attribute__ | ( | (packed) |  | ) |